#include "common.h"
#define SIZE 0x3000

int main() {
	int fd = do_open0();
	int bfd = do_create_buf(fd, SIZE, 0x40);

	char *buffer = (char *) mmap(0, SIZE, PROT_READ | PROT_WRITE, MAP_SHARED, bfd, 0);
	if (buffer == MAP_FAILED)
		syserr("mmap");

	do_munmap(buffer + 0x2000, 0x1000);

	uint32_t *cmd = (uint32_t*) (buffer + 0x1000);
	cmd[0] = FHARDDOOM_USER_DRAW_LINE_HEADER(0, 0xaa);
	cmd[1] = FHARDDOOM_USER_DRAW_LINE_W1(0, 0);
	cmd[2] = FHARDDOOM_USER_DRAW_LINE_W2(31, 31);
	do_run(fd, bfd, 0x1000, sizeof(uint32_t) * 3, 1, &bfd);
	do_wait(fd, 0);

	for (int i = 0; i < 0x40; i++)
		for (int j = 0; j < 0x40; j++) {
			const char expected = (i == j && i < 0x20) ? 0xaa : 0x00;
			if (buffer[i * 0x40 + j] != expected) {
				fprintf(stderr, "Invalid value at (%d, %d)\n", i, j);
				return -1;
			}
		}

	do_close(bfd);
	do_munmap(buffer, SIZE - 0x1000);
	do_close(fd);
	return 0;
}
