#include "common.h"
#define DIM 1024
#define CMDS 1024
#define CMD_SIZE 0x8000

int main() {
	int fd = do_open0();
	int bfd = do_create_buf(fd, 4 * DIM * DIM, 2 * DIM);
	int cmdfd = do_create_buf(fd, CMD_SIZE, 0);

	uint32_t *cmd = (uint32_t *) mmap(0, CMD_SIZE, PROT_READ | PROT_WRITE, MAP_SHARED, cmdfd, 0);
	if (cmd == MAP_FAILED)
		syserr("mmap");

	for (int i = 0; i < CMDS; i++) {
		cmd[3 * i + 0] = FHARDDOOM_USER_FILL_RECT_HEADER(0, 0xaa);
		cmd[3 * i + 1] = FHARDDOOM_USER_FILL_RECT_W1(0, 0);
		cmd[3 * i + 2] = FHARDDOOM_USER_FILL_RECT_W2(DIM, DIM);
	}
	do_run(fd, cmdfd, 0, sizeof(uint32_t) * 3 * CMDS, 1, &bfd);
	
	do_close(bfd);
	do_close(cmdfd);
	do_munmap(cmd, CMD_SIZE);
	do_close(fd);
	return 0;
}
