#include "common.h"
#define SIZE 0x3000

int main() {
	int fd = do_open0();
	int bfd = do_create_buf(fd, SIZE, 0x40);

	char *buffer = (char *) mmap(0, SIZE, PROT_READ | PROT_WRITE, MAP_SHARED, bfd, 0);
	if (buffer == MAP_FAILED)
		syserr("mmap");

	uint32_t *cmd = (uint32_t*) (buffer + 0x1000);
	cmd[0] = FHARDDOOM_USER_DRAW_LINE_HEADER(0, 0xaa);
	cmd[1] = FHARDDOOM_USER_DRAW_LINE_W1(0, SIZE >> 6);
	cmd[2] = FHARDDOOM_USER_DRAW_LINE_W2(31, 31 + (SIZE >> 6));
	do_run_and_wait_with_err(fd, bfd, 0x1000, sizeof(uint32_t) * 3, 1, &bfd);

	do_close(bfd);
	do_munmap(buffer, SIZE);
	do_close(fd);
	return 0;
}
