#include "common.h"
#define SIZE 0x3000
#define CMD_OFFSET 0x1000

int main() {
	int fd = do_open0();
	int bfd = do_create_buf(fd, SIZE, 0x40);

	char *buffer = (char *) mmap(0, SIZE, PROT_READ | PROT_WRITE, MAP_SHARED, bfd, 0);
	if (buffer == MAP_FAILED)
		syserr("mmap");


	uint32_t *cmd = (uint32_t*) (buffer + CMD_OFFSET);
	cmd[0] = FHARDDOOM_USER_DRAW_LINE_HEADER(0, 0xaa);
	cmd[1] = FHARDDOOM_USER_DRAW_LINE_W1(0, 0);
	cmd[2] = FHARDDOOM_USER_DRAW_LINE_W2(31, 31);

	do_run_and_wait_with_err(fd, bfd, CMD_OFFSET, sizeof(uint32_t) * 1, 1, &bfd);

	do_munmap(buffer, SIZE);
	do_close(bfd);
	do_close(fd);
	return 0;
}
